<link rel="import" href="/extern/bower_components/polymer/polymer.html">
<link rel="import" href="/extern/bower_components/paper-toast/paper-toast.html">
<link rel="import" href="/extern/bower_components/paper-dialog/paper-dialog.html">
<link rel="import" href="/extern/bower_components/paper-dialog-scrollable/paper-dialog-scrollable.html">
<link rel="import" href="/extern/bower_components/paper-button/paper-button.html">
<link rel="import" href="throws-toast.html">
<link rel="import" href="/ts/common-elements/reset-css/reset-css.html">

<!--

`ag-toaster` can globally receive messages to show to the user.
These can be displayed as a [paper-toast](https://elements.polymer-project.org/elements/paper-toast) on the bottom of the screen. A [paper-toast](https://elements.polymer-project.org/elements/paper-toast) with clickable options. Or a [paper-dialog](https://elements.polymer-project.org/elements/paper-dialog) forcing the user to choose an option.

Only one `ag-toaster` should exist per project.
To be able to send messages to this element, regardless of location, implement the 'throwsToast' behavior in your element.

Example:

    <ag-toaster></ag-toaster>

Element example:

    <link rel="import" href="/ts/ajaxell/html/elements/ag-toaster/throws-toast.html">

    ...

    behaviors: [throwsToast],

    ...

    this.throwToast({
      'type': 'error',
      'message': 'this is a big error, you will need to choose something',
      'options': ['save the world', 'make dinosaurs'],
      'blocking': true,
      'callback': function(response) {
        console.log("you have chosen to", response);
      }
    });


@demo demo/index.html


-->




<dom-module id="ag-toaster">
    <template>
      <style include="reset-css"></style>
      <link rel="stylesheet" type="text/css" href="css/ag-toaster-min.css?__inline=true">

      <paper-dialog modal id="modal" on-iron-overlay-closed="_modalClosed" type$="{{_toast.type}}">
        <h2>{{_toast.type}}</h2>
        <paper-dialog-scrollable>{{_toast.message}}</paper-dialog-scrollable>
        <div class="buttons">
          <template is="dom-repeat" items="{{_toast.options}}" as="option">
            <paper-button on-click="_dialogButtonClick">{{option}}</paper-button>
          </template>
        </div>
      </paper-dialog>

      <paper-toast id="toast" text="{{_toast.message}}" type$="{{_toast.type}}" duration="{{duration}}">
        <template is="dom-repeat" items="{{_toast.options}}" as="option">
          <paper-button on-click="_toastButtonClick">{{option}}</paper-button>
        </template>
      </paper-toast>

    </template>

    <script src="javascript/ag-toaster-min.js?__inline=true"></script>
</dom-module>
